program Memoria;

uses glib,mem_0;

const MaxX    =7;
      MaxY    =4;
      MaxCard =39;

type tCards=array[0..31,0..31] of byte;

var  Cards:tCards;
     Blocks:array[0..63] of pointer;
     DPics:pointer;
     DPal:^tPalette;
     StepNr,Pairs,MaxPairs:integer;


procedure SetMouse(c:integer);
begin
    MPic:=AddPtr(DPics,256+c*16);
end;

procedure Init;
var i,j:integer;
begin
    SetTick(10000);
    DPics:=AddPtr(@Mem0Dat,800);
    DPal:=AddPtr(@Mem0Dat,32);
    InitVideo;
    MInit;SetMouse(0);
    asm mov ax,13h;int 10h;end;
    SetPalette(DPal^);
    for i:=0 to 3 do
      for j:=0 to 9 do
        Blocks[i*10+j]:=AddPtr(DPics,(i*32+40)*320+j*32);
end;

procedure Done;
begin
    DoneVideo;
    SetTick(0);
end;

function SearchFree:integer;
var i,j,r:integer;
begin r:=-1;
    repeat
      i:=random(MaxY+1);
      j:=random(MAxX+1);
      if Cards[i,j]=$ff then r:=i*32+j;
    until r<>-1;
    SearchFree:=r;
end;

procedure InitGame;
var i,j,x,y:integer;
begin
    for i:=0 to MaxY do
      for j:=0 to MaxX do
        Cards[i,j]:=$ff;
    for i:=1 to (MaxX+1)*(MaxY+1) div 2 do begin
      j:=random(MaxCard+1);
      x:=SearchFree;
      y:=x div 32;x:=x mod 32;
      Cards[y,x]:=j or 128;
      x:=SearchFree;
      y:=x div 32;x:=x mod 32;
      Cards[y,x]:=j or 128;
    end;
    Pairs:=0;MaxPairs:=(MaxX+1)*(MaxY+1) div 2;
    StepNr:=0;
end;

procedure PutSBlock(x,y,w,p:integer);
var xx,ox,i:integer;
begin ox:=x;i:=w; if w<0 then w:=-w;
    xx:=x+4+(32-(w*32)div 40)div 2;
    x:=x+(40-w) div 2;
    if i>0 then begin
      if ox<>x then ClearScrXY(x-1,y,1,40,ScreenPtr);
      if w<=38 then ClearScrXY(x+w,y,1,40,ScreenPtr);
    end;
    if p<0 then begin
      PutPicS(x,y,40,40,w,40,40,0,DPics,ScreenPtr)
    end else begin
      PutPicS(x,y,40,40,w,40,0,0,DPics,ScreenPtr);
      PutPicS(xx,y+4,32,32,w*32 div 40,32,0,0,Blocks[p],ScreenPtr);
    end;
end;

procedure RotateBlock(x,y,p1,p2:integer);
var i:integer;
begin
    for i:=40 downto -40 do begin
      MGet;MDraw;MMove;
      WTicks(1);
      MPut;
      if i>0 then PutSBlock(x,y,i,p1);
      if i<0 then PutSBlock(x,y,i,p2);
    end;
end;

procedure PutSBlock2(x,y,h,p:integer);
var yy,oy,i:integer;
begin oy:=y;i:=h; if h<0 then h:=-h;
    yy:=y+4+(32-(h*32)div 40)div 2;
    y:=y+(40-h) div 2;
    if i>0 then begin
      if oy<>y then ClearScrXY(x,y-1,40,1,ScreenPtr);
      if h<=38 then ClearScrXY(x,y+h,40,1,ScreenPtr);
    end;
    if p<0 then begin
      PutPicS(x,y,40,40,40,h,40,0,DPics,ScreenPtr)
    end else begin
      PutPicS(x,y,40,40,40,h,0,0,DPics,ScreenPtr);
      PutPicS(x+4,yy,32,32,32,h*32 div 40,0,0,Blocks[p],ScreenPtr);
    end;
end;

procedure RotateBlock2(x,y,p0,p1:integer);
var i:integer;
begin
    for i:=40 downto -40 do begin
      MGet;MDraw;MMove;
      WTicks(1);
      MPut;
      if i>0 then PutSBlock2(x,y,i,p1);
      if i<0 then PutSBlock2(x,y,i,p0);
    end;
end;

procedure FlipBlocks(x,y:integer);
begin
    RotateBlock2(x*40,y*40,Cards[y,x],Cards[y,x]);
end;

procedure BlackPal;
var p:tPalette;
    i:integer;
begin for i:=0 to 767 do p[i]:=0;
    SetPalette(p);
end;

procedure FadeOut;
var i,j:integer;
    p:tPalette;
begin p:=DPal^;
    for i:=0 to 63 do begin
      for j:=0 to 767 do
        if p[j]>0 then dec(p[j]);
      WTicks(1);
      SetPalette(p);
    end;
end;

procedure FadeIn;
var i,j:integer;
    p:tPalette;
begin for i:=0 to 767 do p[i]:=0;
    for i:=0 to 63 do begin
      for j:=0 to 767 do
        if p[j]<DPal^[j] then inc(p[j]);
      WTicks(1);
      SetPalette(p);
    end;
end;

procedure DrawScreen;
var i,j,p:integer;
begin
    ClearScr(ScreenPtr);
    for i:=0 to MaxY do
      for j:=0 to MaxX do begin
        if Cards[i,j]>=128 then p:=-1 else p:=CArds[i,j];
        if p<0 then PutPic(j*40,i*40,40,40,40,0,DPics,ScreenPtr) else begin
               PutPic(j*40,i*40,40,40,0,0,DPics,ScreenPtr);
               PutPic(j*40+4,i*40+4,32,32,0,0,Blocks[p],ScreenPtr);
        end;
      end;
end;

procedure WriteNr(x,y,n:integer);
begin
    repeat
      x:=x-24;
      PutPicT(x,y,24,24,80+(n mod 10)*24,16,DPics,ScreenPtr);
      n:=n div 10;
    until n=0;
end;

procedure WriteStep;
var j,p:integer;
begin
    for j:=MaxX-2 to MaxX do begin
      if Cards[0,j]>=128 then p:=-1 else p:=Cards[0,j];
      if p<0 then PutPic(j*40,0,40,40,40,0,DPics,ScreenPtr) else begin
             PutPic(j*40,0,40,40,0,0,DPics,ScreenPtr);
             PutPic(j*40+4,4,32,32,0,0,Blocks[p],ScreenPtr);
      end;
    end;
    WriteNr(320,0,StepNr);
end;

function MyEvent:integer;
var e:integer;
begin e:=0;
   repeat
     e:=MEvent;
     if (e=1) then if Hi(GetKey)=1 then e:=-1 else e:=0;
     if e=2 then e:=0;
     if e=3 then if ((Mb and 1)=1) and ((Ob and 1)=0) then e:=1 else
                 if ((Mb and 2)=2) and ((Ob and 2)=0) then e:=-2 else e:=0;
   until e<>0;
   MyEvent:=e;
end;

function GetPos:integer;
label __Start;
var e,ix,iy:integer;
begin
__Start:
   e:=MyEvent;
   if e=1 then begin
     ix:=Mx div 40;
     iy:=My div 40;
     e:=iy*32+ix;
   end;
   if e=-3 then Goto __Start;
   GetPos:=e;
end;

function DoIt:integer;
var e,p0,p1,ix,iy,x0,x1,y0,y1:integer;
begin
   WriteStep;
   SetMouse(0);
   repeat
     e:=GetPos;
     if e>=0 then begin
       ix:=e mod 32;x0:=ix;
       iy:=e div 32;y0:=iy;
       p0:=Cards[iy,ix];
       if (p0 and 128)=0 then begin
         RotateBlock(ix*40,iy*40,p0 and $7f,-1);
         RotateBlock(ix*40,iy*40,-1,p0 and $7f);
         e:=1;
       end else begin
         RotateBlock(ix*40,iy*40,-1,p0 and $7f);
         e:=0;
       end;
     end;
   until e<=0;
   SetMouse(1);
 if e=0 then
   repeat
     e:=GetPos;
     if e>=0 then begin
       ix:=e mod 32;x1:=ix;
       iy:=e div 32;y1:=iy;
       p1:=Cards[iy,ix];
       if (p1 and 128)=0 then begin
         RotateBlock(ix*40,iy*40,p1 and $7f,-1);
         RotateBlock(ix*40,iy*40,-1,p1 and $7f);
         e:=1;
       end else
       if (x1=x0) and (y1=y0) then e:=1 else begin
         RotateBlock(ix*40,iy*40,-1,p1 and $7f);
         e:=0;
       end;
     end;
   until e<=0;
 if e=0 then begin
     if p0=p1 then begin
       SetMouse(2);
       Inc(Pairs);
       Cards[y0,x0]:=p0 and $7f;
       Cards[y1,x1]:=p1 and $7f;
       FlipBlocks(x0,y0);
       FlipBlocks(x1,y1);
     end else
     begin
       SetMouse(3);
       RotateBlock(x0*40,y0*40,p0 and $7f,-1);
       RotateBlock(x1*40,y1*40,p1 and $7f,-1);
     end;
   end;
   if Pairs>=MaxPairs then e:=-3;
   if e=0 then Inc(StepNr);
   DoIt:=e;
end;

procedure Gratul;
begin
   PutPicT(72,92,176,16,80,0,DPics,ScreenPtr);
   FadeIn;
   GetKey;
end;

procedure Intro;
label __Exit;
const st:array[0..6] of byte=(10,11,10,12,13,14,15);
      yy=40;
var i,j:integer;
begin Mon:=false;
   for j:=0 to 6 do begin
     for i:=0 to 40 do begin
       PutSBlock2(20+j*40,yy,i,-1);
       WTicks(1);
       if KeyPressed then goto __exit;
     end;
   end;
   for j:=0 to 6 do begin
     RotateBlock(20+j*40,yy,-1,st[j]);
       if KeyPressed then goto __exit;
   end;
   for i:=0 to 31 do begin
     PutPicS(140,yy+50,60,32,60,i,260,168,DPics,ScreenPtr);
     WTicks(1);
     if KeyPressed then goto __exit;
   end;
   for i:=200 downto 130 do begin
     PutPic(32,i,256,32,0,168,DPics,ScreenPtr);
     WTicks(1);
     if KeyPressed then goto __exit;
   end;
__Exit:
   repeat
     GetKey;
   until Not Keypressed;
   FadeOut;
   Mon:=true;
end;

procedure Game;
var EndIt:boolean;
    r:integer;
begin EndIt:=false;
    repeat
      InitGame;
      BlackPal;
      DrawScreen;
      FadeIn;
      repeat
        r:=DoIt;
      until r<>0;
      if r=-1 then EndIt:=true;
      if r=-3 then Gratul;
      FadeOut;
    until EndIt;
end;

begin
   Init;
   Intro;
   Game;
   Done;
end.
